/*
 * Created on Jan 25, 2005
 */
package com.alwara.graphLayout.test;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;

import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.KeyStroke;


public class GraphWindow extends JFrame {
    private static final long serialVersionUID = -1L;
    public static int WINDOW_WIDTH = 500;
    public static int WINDOW_HEIGHT = 500;
    
   int[][] nodes = new int[][] {
         {25, 30},
         {100, 200},
         {30, 130},
         {200, 200},
         {230, 130},
         {230, 330},
   }; 
   
   int[][] edges = new int[][] {
          {0, 3, 0, 4, 0, 2},
          {0, 0, 0, 0, 0, 2},
          {0, 0, 0, 0, 0, 0},
          {0, 0, 3, 0, 0, 2},
          {0, 0, 3, 5, 0, 0},
          {1, 0, 0, 1, 0, 0},
   };
   
    public GraphWindow() {
	    Graph graph = new Graph();
	    
	    Node[] nodeList = new Node[nodes.length];
	    Edge[][] edgeList = new Edge[edges.length][edges[0].length];
	    
	    for (int i = 0; i < nodeList.length; i++) {
            nodeList[i] = new Node(nodes[i][0], nodes[i][1], false);
	        graph.addNode(nodeList[i]);
        }
        
	    for (int i = 0; i < edgeList.length; i++) {
	        Node node1 = nodeList[i];
		    for (int j = 0; j < edgeList[i].length; j++) {
		        Node node2 = nodeList[j];
		        int weight = edges[i][j];
		        if (weight > 0) {
		            Edge edge = new Edge(node1, node2, weight);
		            graph.addEdge(edge);
		        }
		    }
        }
	    
	    GraphPanel panel = new GraphPanel(graph);
	    add(panel);
        registerCloseActions();
    }
    
    public static void main(String[] args) {
        GraphWindow window = new GraphWindow();
        
        window.setPreferredSize(new Dimension(WINDOW_WIDTH, WINDOW_HEIGHT));
	    window.pack();
	    window.setVisible(true);
    }

    private void registerCloseActions() {
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    
        KeyStroke stroke = KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0);
        this.rootPane.registerKeyboardAction(new CloseActionListener(), stroke,
                JComponent.WHEN_IN_FOCUSED_WINDOW);
    }

    class CloseActionListener implements ActionListener {
        public void actionPerformed(ActionEvent arg0) {
            setVisible(false);
            System.exit(0);
        }
    }
}