/*
 * Created on Jan 3, 2005
 */
package com.alwara.uml;

import java.util.HashMap;
import java.util.Map;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;

/**
 * @author Virender Singh Dogra
 * The main plugin class to be used in the desktop.
 */
public class EclipseUMLBotPlugin extends AbstractUIPlugin {
   //The shared instance.
   private static EclipseUMLBotPlugin plugin;
   //Resource bundle.
   private ResourceBundle resourceBundle;
   private Map classMap_ = new HashMap();
   
   /**
    * The constructor.
    */
   public EclipseUMLBotPlugin() {
      super();
      plugin = this;
   }

   /**
    * {@inheritDoc}
    * This method is called upon plug-in activation
    */
   public void start(BundleContext context) throws Exception {
      super.start(context);
   }

   /**
    * {@inheritDoc}
    * This method is called when the plug-in is stopped
    */
   public void stop(BundleContext context) throws Exception {
      super.stop(context);
      plugin = null;
      resourceBundle = null;
   }

   /**
    * Returns the shared instance.
    * @return a plugin instance
    */
   public static EclipseUMLBotPlugin getDefault() {
      return plugin;
   }

   /**
    * Returns the string from the plugin's resource bundle,
    * or 'key' if not found.
    * @param key
    * @return a resource string?
    */
   public static String getResourceString(String key) {
      ResourceBundle bundle = EclipseUMLBotPlugin.getDefault().getResourceBundle();
      try {
         return (bundle != null) ? bundle.getString(key) : key;
      } catch (MissingResourceException e) {
         return key;
      }
   }

   /**
    * Returns the plugin's resource bundle,
    * @return a resource bundle
    */
   public ResourceBundle getResourceBundle() {
      try {
         if (resourceBundle == null)
            resourceBundle = ResourceBundle.getBundle("com.alwara.uml.ClazzDiagramPluginResources");
      } catch (MissingResourceException x) {
         resourceBundle = null;
      }
      return resourceBundle;
   }

   public void analyse(IJavaElement javaElement) {
      // TODO Auto-generated method stub
   }

   public void showPerspective() {
      // TODO Auto-generated method stub
   }

   /**
    * @param javaElement
    */
   public void addClass(IJavaElement javaElement) {
      classMap_.put(javaElement.getElementName(), javaElement);
   }
}
