/*
 * Created on Jan 3, 2005
 */
package com.alwara.uml;

import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;


/**
 * @author Virender Singh Dogra
 * Provides the menu item on the context menu on the package/navigator view 
 */
public class ShowClassDiagram implements IWorkbenchWindowActionDelegate {
    private ISelection selection;

    public void run( IAction action ) {
        try {
            IStructuredSelection structuredSelection = ( IStructuredSelection ) selection;
            IJavaElement javaElement = ( IJavaElement ) structuredSelection.getFirstElement();
            
            getPlugin().analyse(javaElement);
            getPlugin().addClass(javaElement);
        } catch ( Throwable e ) {
            e.printStackTrace();
            MessageDialog.openError( null, "Error", e.getMessage() );
        }
    }

    /**
    * @return the plugin instance that is a central place to share stuff
    */
   private EclipseUMLBotPlugin getPlugin() {
      return EclipseUMLBotPlugin.getDefault();
   }

   public void selectionChanged( IAction action, ISelection newSelection ) {
        selection = newSelection;
    }

    public void dispose() {
    }

    public void init( IWorkbenchWindow window ) {
    }
}

