package com.alwara.uml;

import org.eclipse.gef.ui.actions.ActionBarContributor;
import org.eclipse.gef.ui.actions.DeleteRetargetAction;
import org.eclipse.gef.ui.actions.RedoRetargetAction;
import org.eclipse.gef.ui.actions.UndoRetargetAction;
import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.ui.actions.ActionFactory;

/**
 * Tool bar adder
 */
public class UMLToolbarContributor extends ActionBarContributor {

   /**
    * {@inheritDoc}
    */
   protected void buildActions() {
      addRetargetAction(new UndoRetargetAction());
      addRetargetAction(new RedoRetargetAction());
      addRetargetAction(new DeleteRetargetAction());
   }

   /**
    * {@inheritDoc}
    */
   protected void declareGlobalActionKeys() {
   }

   /**
    * {@inheritDoc}
    */
   public void contributeToToolBar(IToolBarManager toolBarManager) {
      toolBarManager.add(getActionRegistry().getAction(ActionFactory.UNDO.getId()));
      toolBarManager.add(getActionRegistry().getAction(ActionFactory.REDO.getId()));
      toolBarManager.add(getActionRegistry().getAction(ActionFactory.DELETE.getId()));
    }
}
