/*
 * Created on Jan 1, 2005
 */
package com.alwara.uml.clazz;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;

import com.alwara.uml.clazz.controller.ClazzDiagramEditPart;
import com.alwara.uml.clazz.controller.ClazzEditPart;
import com.alwara.uml.clazz.controller.MethodContainerEditPart;
import com.alwara.uml.clazz.controller.PropertyContainerEditPart;
import com.alwara.uml.clazz.model.ClazzModel;
import com.alwara.uml.clazz.model.MethodContainerModel;
import com.alwara.uml.clazz.model.PropertyContainerModel;
import com.alwara.uml.clazz.model.ClazzDiagramModel;
import com.alwara.uml.controller.ArrowConnectionEditPart;
import com.alwara.uml.controller.ImplementsConnectionEditPart;
import com.alwara.uml.controller.LineConnectionEditPart;
import com.alwara.uml.model.ArrowConnectionModel;
import com.alwara.uml.model.ImplementsConnectionModel;
import com.alwara.uml.model.LineConnectionModel;

/**
 * @author Virender Singh Dogra
 */
public class ClazzDiagramEditPartFactory implements EditPartFactory {

   public EditPart createEditPart(EditPart context, Object model) {
      EditPart part = null;
      
      if (model instanceof ClazzDiagramModel) {
         part = new ClazzDiagramEditPart();
      }
      else if (model instanceof ClazzModel) {
         part = new ClazzEditPart();
      } 
      else if (model instanceof PropertyContainerModel) {
         part = new PropertyContainerEditPart();
      } 
      else if (model instanceof MethodContainerModel) {
         part = new MethodContainerEditPart();
      } 
      else if (model instanceof LineConnectionModel) {
         part = new LineConnectionEditPart();
      } 
      else if (model instanceof ArrowConnectionModel) {
         part = new ArrowConnectionEditPart();
      } 
      else if (model instanceof ImplementsConnectionModel) {
         part = new ImplementsConnectionEditPart();
      } 
      
      part.setModel(model);
      
      return part;
   }
}