/*
 * Created on Jan 1, 2005
 */
package com.alwara.uml.clazz.controller;

import java.util.List;

import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.XYLayout;
import org.eclipse.gef.EditPolicy;

import com.alwara.uml.clazz.controller.editpolicy.ClazzDiagramEditPolicy;
import com.alwara.uml.clazz.model.ClazzDiagramModel;
import com.alwara.uml.clazz.view.ClazzDiagramFigure;
import com.alwara.uml.controller.EditPartWithListener;

/**
 * @author Virender Singh Dogra
 * Controller for the whole diagram.
 */
public class ClazzDiagramEditPart extends EditPartWithListener {

   protected IFigure createFigure() {
      Figure newFigure = new ClazzDiagramFigure();
      newFigure.setLayoutManager(new XYLayout());
      return newFigure;
   }

   protected void createEditPolicies() {
      installEditPolicy(EditPolicy.CONTAINER_ROLE, null);
      installEditPolicy(EditPolicy.LAYOUT_ROLE, new ClazzDiagramEditPolicy());
   }
   
   protected List getModelChildren() {
      return getClassDiagram().getClazzes();
   }

   /**
    * @return the class diagram model 
    */
   public ClazzDiagramModel getClassDiagram() {
      return (ClazzDiagramModel) getModel();
   }

}
