/*
 * Created on Jan 1, 2005
 */
package com.alwara.uml.clazz.controller;

import java.beans.PropertyChangeEvent;
import java.util.List;

import org.eclipse.draw2d.ChopboxAnchor;
import org.eclipse.draw2d.ConnectionAnchor;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.ConnectionEditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.NodeEditPart;
import org.eclipse.gef.Request;

import com.alwara.uml.clazz.controller.editpolicy.ClazzEditPolicy;
import com.alwara.uml.clazz.controller.editpolicy.ClazzNodeEditPolicy;
import com.alwara.uml.clazz.model.ClazzModel;
import com.alwara.uml.clazz.view.ClazzFigure;
import com.alwara.uml.controller.EditPartWithListener;

/**
 * @author Virender Singh Dogra
 * Controller for the class.
 */
public class ClazzEditPart extends EditPartWithListener implements NodeEditPart {

   protected IFigure createFigure() {
      return new ClazzFigure(getClazz());
   }

   /**
    * @return return the class that is controlled by this edit part
    */
   private ClazzModel getClazz() {
      return (ClazzModel) getModel();
   }
   
   protected void refreshVisuals() {
      Rectangle constraint = getClazz().getConstraint();
      ((GraphicalEditPart)getParent()).setLayoutConstraint(this, getFigure(), constraint);
   }
   
//   protected List getModelChildren() {
//      return getClazz().getModelChildren();
//   }
   
   protected void createEditPolicies() {
      installEditPolicy(EditPolicy.COMPONENT_ROLE, new ClazzEditPolicy());
      installEditPolicy(EditPolicy.GRAPHICAL_NODE_ROLE, new ClazzNodeEditPolicy());
   }

   public ConnectionAnchor getSourceConnectionAnchor(ConnectionEditPart connection) {
      return new ChopboxAnchor(getFigure());
   }

   public ConnectionAnchor getTargetConnectionAnchor(ConnectionEditPart connection) {
      return new ChopboxAnchor(getFigure());
   }

   public ConnectionAnchor getSourceConnectionAnchor(Request request) {
      return new ChopboxAnchor(getFigure());
   }

   public ConnectionAnchor getTargetConnectionAnchor(Request request) {
      return new ChopboxAnchor(getFigure());
   }
   
   public void propertyChange(PropertyChangeEvent evt) {
      super.propertyChange(evt);
   }
   
   protected List getModelSourceConnections() {
      return ((ClazzModel)getModel()).getModelSourceConnections();
   }
   
   protected List getModelTargetConnections() {
      return ((ClazzModel)getModel()).getModelTargetConnections();
   }

}