/*
 * Created on Jan 20, 2005
 */
package com.alwara.uml.clazz.controller.command;

import org.eclipse.gef.commands.Command;

import com.alwara.uml.clazz.model.ClazzModel;
import com.alwara.uml.model.AbstractConnectionModel;

/**
 * @author Virender Singh Dogra
 */
public class CreateConnectionCommand extends Command {
   
   private ClazzModel source_, target_;
   private AbstractConnectionModel connection_;

   public boolean canExecute() {
      if ((source_ == null) || (target_ == null)) {
         return false;
      }
      
      if (source_.equals(target_)) {
         return false;
      }
      
      return true;
   }
   
   public void execute() {
      connection_.attachSource();
      connection_.attachTarget();
   }
   
   public void setConnection(Object model) {
      connection_ = (AbstractConnectionModel) model;
   }
   
   public void setSource(Object model) {
      source_ = (ClazzModel) model;
      connection_.setSource(source_);
   }
   
   public void setTarget(Object model) {
      target_ = (ClazzModel) model;
      connection_.setTarget(target_);
   }
   
   public void undo() {
      connection_.detachSource();
      connection_.detachTarget();
   }
}
