/*
 * Created on Jan 2, 2005
 */
package com.alwara.uml.clazz.controller.editpolicy;

import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.XYLayoutEditPolicy;
import org.eclipse.gef.requests.CreateRequest;

import com.alwara.uml.clazz.controller.command.ChangeConstraintCommand;
import com.alwara.uml.clazz.controller.command.ClazzAddCommand;
import com.alwara.uml.clazz.model.ClazzDiagramModel;
import com.alwara.uml.clazz.model.ClazzModel;

/**
 * @author Virender Singh Dogra
 */
public class ClazzDiagramEditPolicy extends XYLayoutEditPolicy {

   protected Command getCreateCommand(CreateRequest request) {
      Object newObject = request.getNewObject();
      
      ClazzDiagramModel diagramModel = (ClazzDiagramModel) getHost().getModel();
      ClazzAddCommand clazzAddCommand = new ClazzAddCommand();
      
      ClazzModel clazzModel = (ClazzModel) newObject;
      clazzModel.setConstraint((Rectangle) getConstraintFor(request));
      
      clazzAddCommand.setClazzDiagramModel(diagramModel);
      clazzAddCommand.setClazzModel(clazzModel);
      return clazzAddCommand;
   }

   protected Command createAddCommand(EditPart child, Object constraint) {
      return null;
   }

   /**
    * {@inheritDoc}
    */
   protected Command createChangeConstraintCommand(EditPart child, Object constraint) {
      ChangeConstraintCommand command = new ChangeConstraintCommand();
      command.setModel(child.getModel());
      command.setConstraint((Rectangle) constraint);
      
      return command;
   }

   /**
    * {@inheritDoc}
    */
   protected Command getDeleteDependantCommand(Request request) {
      return null;
   }

   /**
    * {@inheritDoc}
    */
   public Command getCommand(Request request) {
      System.out.println(request.getType());
      return super.getCommand(request);
   }
}
