/*
 * Created on Jan 20, 2005
 */
package com.alwara.uml.clazz.controller.editpolicy;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.GraphicalNodeEditPolicy;
import org.eclipse.gef.requests.CreateConnectionRequest;
import org.eclipse.gef.requests.ReconnectRequest;

import com.alwara.uml.clazz.controller.command.CreateConnectionCommand;
import com.alwara.uml.controller.command.ReconnectConnectionCommand;

/**
 * @author Virender Singh Dogra
 */
public class ClazzNodeEditPolicy extends GraphicalNodeEditPolicy {

   protected Command getConnectionCompleteCommand(CreateConnectionRequest request) {
      CreateConnectionCommand command = (CreateConnectionCommand) request.getStartCommand();
      command.setTarget(getHost().getModel());
      return command;
   }

   protected Command getConnectionCreateCommand(CreateConnectionRequest request) {
      CreateConnectionCommand command = new CreateConnectionCommand();
      command.setConnection(request.getNewObject());
      command.setSource(getHost().getModel());
      request.setStartCommand(command);
      return command;
   }

   protected Command getReconnectTargetCommand(ReconnectRequest request) {
      ReconnectConnectionCommand command = new ReconnectConnectionCommand();
      command.setConnectionModel(request.getConnectionEditPart().getModel());
      command.setNewTarget(getHost().getModel());
      return command;
    }

    protected Command getReconnectSourceCommand(ReconnectRequest request) {
      ReconnectConnectionCommand command = new ReconnectConnectionCommand();
      command.setConnectionModel(request.getConnectionEditPart().getModel());
      command.setNewSource(getHost().getModel());
      return command;
    }
}
