/*
 * Created on Jan 1, 2005
 */
package com.alwara.uml.clazz.model;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.alwara.uml.model.AbstractModel;

/**
 * @author Virender Singh Dogra
 */
public class ClazzDiagramModel extends AbstractModel {
   /** Comment for <code>serialVersionUID</code> */
   private static final long serialVersionUID = 1L;

   private List clazzes_ = new ArrayList();
   private Map clazzMap = new HashMap();

   /**
    * @param clazzModel
    */
   public void addClazz(ClazzModel clazzModel) {
      clazzes_.add(clazzModel);
      clazzMap.put(clazzModel.getName(), clazzModel);
      firePropertyChange(CHILD, null, clazzModel);
   }

   /**
    * @return the list of classes in the model
    */
   public List getClazzes() {
      return clazzes_;
   }
   
   /**
    * @param clazz
    */
   public void removeClazz(ClazzModel clazz){
      clazzes_.remove(clazz);
      clazzMap.remove(clazz);
      firePropertyChange(CHILD, null, clazz);
   }
}
