/*
 * Created on Jan 1, 2005
 */
package com.alwara.uml.clazz.model;

import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.jdt.core.ICompilationUnit;
import org.eclipse.jdt.core.IMethod;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.internal.corext.callhierarchy.CallHierarchy;
import org.eclipse.jdt.internal.corext.callhierarchy.MethodWrapper;

import com.alwara.uml.model.AbstractModel;
import com.alwara.uml.utils.Logger;

/**
 * @author Virender Singh Dogra
 */
public class MethodContainerModel extends AbstractModel {
   static Logger logger_ = Logger.getLogger(MethodContainerModel.class);

   /** Comment for <code>serialVersionUID</code> */
   private static final long serialVersionUID = 1L;

   private ClazzModel clazzModel_;

   private IMethod[] methodList_ = new IMethod[0];

   /**
    * @param clazz
    */
   public MethodContainerModel(ClazzModel clazzModel, ICompilationUnit clazz) {
      clazzModel_ = clazzModel;
      
      if (clazz != null){
         try {
            IType[] typeArray = clazz.getAllTypes();
            for (int i = 0; i < typeArray.length; i++){
               IType type = typeArray[i];
               if (type.isClass()) {
                  IMethod[] methods = type.getMethods();
                  
                  methodList_ = methods;
                  
                  //TODO: move this elsewhere:
                  //list of methods called
                  for (int j = 0; j < methods.length; j++) {
                     IMethod method = methods[j];
                     
                     MethodWrapper test = new CallHierarchy().getCalleeRoot(method);
                     MethodWrapper[] calls = test.getCalls(new NullProgressMonitor());
                     
                     int a = calls.length;
                     
                  }
                  
                  //TODO: handle other inner classes also. 
                  break;
               }
            }
         }
         catch (Exception e) {
            logger_.error("Error while getting method names", e);
         }
      }

   }

   public IMethod[] getMethodList() {
      return methodList_;
   }
}