/*
 * Created on Jan 1, 2005
 */
package com.alwara.uml.clazz.model;

import org.eclipse.jdt.core.ICompilationUnit;
import org.eclipse.jdt.core.IField;
import org.eclipse.jdt.core.IType;

import com.alwara.uml.model.AbstractModel;
import com.alwara.uml.utils.Logger;

/**
 * @author Virender Singh Dogra
 */
public class PropertyContainerModel extends AbstractModel {
   static Logger logger_ = Logger.getLogger(PropertyContainerModel.class);

   /** Comment for <code>serialVersionUID</code> */
   private static final long serialVersionUID = 1L;
   private ClazzModel clazzModel_;

   private IField[] propertyList_ = new IField[0];

   /**
    * @param clazzModel
    * @param clazz
    */
   public PropertyContainerModel(ClazzModel clazzModel, ICompilationUnit clazz) {
      clazzModel_ = clazzModel;
      
      if (clazz != null) {
         try {
            IType[] typeArray = clazz.getAllTypes();
            for (int i = 0; i < typeArray.length; i++){
               IType type = typeArray[i];
               
               if (type.isClass()) {
                  IField[] fields = type.getFields();
                  
                  propertyList_ = fields;
                  
                  //TODO: handle other inner classes also. 
                  break;
               }
            }
            
         }
         catch (Exception e) {
            logger_.error("Error while getting method names", e);
         }
      }
   }

   public IField[] getPropertyList() {
      return propertyList_;
   }
}
