/*
 * Created on Jan 1, 2005
 */
package com.alwara.uml.clazz.view;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.widgets.Display;

import com.alwara.uml.clazz.model.ClazzModel;
import com.alwara.uml.view.IconImage;

/**
 * @author Virender Singh Dogra
 */
public class ClazzFigure extends Figure {
   private final ClazzModel clazz_;
   
   public final static Color classColor = new Color(null, 252, 254, 204); 

   /**
    * @param clazz
    */
   public ClazzFigure(ClazzModel clazz) {
      clazz_ = clazz;

      ToolbarLayout layout = new ToolbarLayout();
      layout.setSpacing(2);
      setLayoutManager(layout);

      Label label = new Label(clazz.getName() + " ", IconImage.getFittingImage(clazz));
      setBorder(new LineBorder(ColorConstants.black, 1));
      setBackgroundColor(classColor);
      setOpaque(true);

      label.setFont(getDecorationFont());

      add(label);
      add(new PropertyContainerFigure(clazz.getPropertyContainerModel()));
      add(new MethodContainerFigure(clazz.getMethodContainerModel()));
   }

   /**
    * @return the font to decorate the class
    */
   private Font getDecorationFont() {
      Font newFont = null;
      FontData fontData = null;

      if (clazz_.isInterfaceOrAbstract()) {
         fontData = Display.getCurrent().getSystemFont().getFontData()[0];
         fontData.setStyle(SWT.ITALIC);
      }
      else {
         fontData = Display.getCurrent().getSystemFont().getFontData()[0];
         fontData.setStyle(SWT.BOLD);
      }

      newFont = new Font(null, fontData);

      return newFont;
   }

}