/*
 * Created on Jan 1, 2005
 */
package com.alwara.uml.clazz.view;

import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.jdt.core.IField;
import org.eclipse.jdt.core.JavaModelException;
import org.eclipse.jdt.core.Signature;
import org.eclipse.swt.graphics.Color;

import com.alwara.uml.clazz.model.PropertyContainerModel;
import com.alwara.uml.view.CompartmentFigureBorder;
import com.alwara.uml.view.IconImage;

/**
 * @author Virender Singh Dogra
 */
public class PropertyContainerFigure extends Figure {
   public final static Color containerColor = new Color(null, 252, 254, 252); 

   private final PropertyContainerModel propertyListModel_;

   /**
    * @param propertyContainerModel
    */
   public PropertyContainerFigure(PropertyContainerModel propertyContainerModel) {
      this.propertyListModel_ = propertyContainerModel;

      ToolbarLayout layout = new ToolbarLayout();
      layout.setSpacing(2);
      layout.setMinorAlignment(ToolbarLayout.ALIGN_TOPLEFT);
      setLayoutManager(layout);

      if (propertyContainerModel.getPropertyList().length > 0) {
         try {
            IField[] fieldArray = propertyContainerModel.getPropertyList();
            for (int i = 0; i < fieldArray.length; i++) {
               IField field = fieldArray[i];
               
               Label label;
               label = new Label(getFieldSignature(field), IconImage
                        .getFittingImage(field));
               label.setLabelAlignment(Label.LEFT);
               add(label);
            }
         }
         catch (JavaModelException e) {
            e.printStackTrace();
         }
      }
      else { //Atleast show an empty container if no properties found
         Label label = new Label(" ");
         add(label);
      }
      
      setBorder(new CompartmentFigureBorder());
      setBackgroundColor(containerColor);
      setOpaque(true);
   }

   /**
    * @param field
    * @return the field signature
    * @throws JavaModelException
    */
   private String getFieldSignature(IField field) throws JavaModelException {
      return field.getElementName() + " : " + Signature.toString(field.getTypeSignature());
   }

}
