package com.alwara.uml.controller.command;

import org.eclipse.draw2d.geometry.Point;
import org.eclipse.gef.commands.Command;

import com.alwara.uml.model.AbstractConnectionModel;

public class MoveBendpointCommand extends Command {
   private AbstractConnectionModel connection;

   private Point oldLocation, newLocation;

   private int index;

   public void execute() {
      oldLocation = (Point) connection.getBendpoints().get(index);
      connection.replaceBendpoint(index, newLocation);
   }

   public void setConnectionModel(Object model) {
      connection = (AbstractConnectionModel) model;
   }

   public void setIndex(int i) {
      index = i;
   }

   public void setNewLocation(Point point) {
      newLocation = point;
   }

   public void undo() {
      connection.replaceBendpoint(index, oldLocation);
   }

}