/*
 * Created on Jan 24, 2005
 */
package com.alwara.uml.controller.command;

import org.eclipse.gef.commands.Command;

import com.alwara.uml.model.AbstractConnectionModel;
import com.alwara.uml.model.AbstractNodeModel;

/**
 * @author Virender Singh Dogra
 */
public class ReconnectConnectionCommand extends Command {
   private AbstractConnectionModel connection;

   private AbstractNodeModel newSource = null, 
                             newTarget = null, 
                             oldSource = null,
                             oldTarget = null;

   public void execute() {
      if (newSource != null) {
         oldSource = connection.getSource();
         reconnectSource(newSource);
      }

      if (newTarget != null) {
         oldTarget = connection.getTarget();
         reconnectTarget(newTarget);
      }
   }

   private void reconnectSource(AbstractNodeModel source) {
      connection.detachSource();
      connection.setSource(source);
      connection.attachSource();
   }

   private void reconnectTarget(AbstractNodeModel target) {
      connection.detachTarget();
      connection.setTarget(target);
      connection.attachTarget();
   }

   public void setConnectionModel(Object model) {
      connection = (AbstractConnectionModel) model;
   }

   public void setNewSource(Object model) {
      newSource = (AbstractNodeModel) model;
   }

   public void setNewTarget(Object model) {
      newTarget = (AbstractNodeModel) model;
   }

   // ???????
   public void undo() {
      if (oldSource != null)
         reconnectSource(oldSource);
      if (oldTarget != null)
         reconnectTarget(oldTarget);

      oldSource = null;
      oldTarget = null;
   }
}
