/*
 * Created on Jan 19, 2005
 */
package com.alwara.uml.model;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.draw2d.geometry.Point;


/**
 * @author Virender Singh Dogra
 */
public abstract class AbstractConnectionModel extends AbstractModel {
   
   private AbstractNodeModel source_, target_;
   private List bendpoints = new ArrayList();
   
   public static final String BEND_POINT = "BEND_POINT";
   
   public void addBendpoint(int index, Point point) {
     bendpoints.add(index, point);
     firePropertyChange(BEND_POINT, null, null);
   }

   public List getBendpoints() {
     return bendpoints;
   }

   public void removeBendpoint(int index) {
     bendpoints.remove(index);
     firePropertyChange(BEND_POINT, null, null);
   }

   public void replaceBendpoint(int index, Point point) {
     bendpoints.set(index, point);
     firePropertyChange(BEND_POINT, null, null);
   }
     
   public void attachSource() {
      if (!source_.getModelSourceConnections().contains(this)) {
         source_.addSourceConnection(this);
      }
   }
   
   public void attachTarget() {
      if (!target_.getModelTargetConnections().contains(this)) {
         target_.addTargetConnection(this);
      }
   }
   
   public void detachSource() {
      source_.removeSourceConnection(this);
   }
   
   public void detachTarget() {
      target_.removeTargetConnection(this);
   }
   
   public AbstractNodeModel getSource() {
      return source_;
   }
   
   public AbstractNodeModel getTarget() {
      return target_;
   }
   
   public void setSource(AbstractNodeModel model) {
      source_ = model;
   }
   
   public void setTarget(AbstractNodeModel model) {
      target_ = model;
   }
}
