/*
 * Created on Jan 20, 2005
 */
package com.alwara.uml.model;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Virender Singh Dogra
 * A model that can act as a node in a connection.
 */
public abstract class AbstractNodeModel extends AbstractModel {
   public static final String SOURCE_CONNECTION = "SOURCE_CONNECTION";
   public static final String TARGET_CONNECTION = "TARGET_CONNECTION";
   
   private List sourceConnections = new ArrayList();
   private List targetConnections = new ArrayList();
   
   public void addSourceConnection(Object connection){
      sourceConnections.add(connection);
      firePropertyChange(SOURCE_CONNECTION, null, null);
   }
   
   public void addTargetConnection(Object connection){
      targetConnections.add(connection);
      firePropertyChange(TARGET_CONNECTION, null, null);
   }
   
   public List getModelSourceConnections(){
      return sourceConnections;
   }
   
   public List getModelTargetConnections(){
      return targetConnections;
   }
   
   public void removeSourceConnection(Object connection){
      sourceConnections.remove(connection);
      firePropertyChange(SOURCE_CONNECTION, null, null);
   }
   
   public void removeTargetConnection(Object connection){
      targetConnections.remove(connection);
      firePropertyChange(TARGET_CONNECTION, null, null);
   }
}
