/*
 * Created on Jan 1, 2005
 */
package com.alwara.uml.sequence;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;

import com.alwara.uml.sequence.controller.InstanceEditPart;
import com.alwara.uml.sequence.controller.MessageEditPart;
import com.alwara.uml.sequence.controller.MethodEditPart;
import com.alwara.uml.sequence.controller.SequenceDiagramEditPart;
import com.alwara.uml.sequence.model.InstanceModel;
import com.alwara.uml.sequence.model.MessageModel;
import com.alwara.uml.sequence.model.MethodModel;
import com.alwara.uml.sequence.model.SequenceDiagramModel;

/**
 * @author Virender Singh Dogra
 */
public class SequenceDiagramEditPartFactory implements EditPartFactory {

   /**
    * {@inheritDoc}
    */
   public EditPart createEditPart(EditPart context, Object model) {
      EditPart part = null;
      
      
      if (model instanceof SequenceDiagramModel) {
         part = new SequenceDiagramEditPart();
      }
      else if (model instanceof InstanceModel) {
         part = new InstanceEditPart();
      } 
      else if (model instanceof MessageModel) {
         part = new MessageEditPart();
      } 
      else if (model instanceof MethodModel) {
         part = new MethodEditPart();
      } 
      
      part.setModel(model);
      
      return part;
   }

}
