/*
 * Created on Jan 15, 2005
 */
package com.alwara.uml.sequence;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.draw2d.FigureCanvas;
import org.eclipse.gef.DefaultEditDomain;
import org.eclipse.gef.GraphicalViewer;
import org.eclipse.gef.ui.parts.GraphicalEditor;
import org.eclipse.gef.ui.parts.ScrollingGraphicalViewer;
import org.eclipse.gef.ui.rulers.RulerComposite;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;

import com.alwara.uml.sequence.model.SequenceDiagramModel;
import com.alwara.uml.sequence.view.MethodDropListener;

/**
 * @author Virender Singh Dogra
 */
public class SequenceDiagramEditor extends GraphicalEditor {

   RulerComposite rulerComp_;

   /** Constructor  */
   public SequenceDiagramEditor() {
      setEditDomain(new DefaultEditDomain(this));
   }
   
   protected void initializeGraphicalViewer() {
      GraphicalViewer viewer = getGraphicalViewer();
      viewer.addDropTargetListener(new MethodDropListener(getGraphicalViewer()));
      
      //TODO: pass the right stuff instead of null
      SequenceDiagramModel parent = new SequenceDiagramModel(null);
//      ClazzModel child = new ClazzModel("junk");
//      child.setConstraint(new Rectangle(0,0,-1, -1));
//      parent.addClazz(child);

      viewer.setContents(parent);
   }
   
   protected void createGraphicalViewer(Composite parent) {
      rulerComp_ = new RulerComposite(parent, SWT.NONE);
      super.createGraphicalViewer(rulerComp_);
      rulerComp_.setGraphicalViewer((ScrollingGraphicalViewer)getGraphicalViewer());
   }

   protected FigureCanvas getEditor(){
      return (FigureCanvas)getGraphicalViewer().getControl();
   }

   protected void configureGraphicalViewer() {
      super.configureGraphicalViewer();
      GraphicalViewer viewer = getGraphicalViewer();
      viewer.setEditPartFactory(new SequenceDiagramEditPartFactory());
   }

   public void doSave(IProgressMonitor monitor) {
   }

   public void doSaveAs() {
   }

   public boolean isDirty() {
      return false;
   }

   public boolean isSaveAsAllowed() {
      return false;
   }
}