/*
 * Created on Jan 15, 2005
 */
package com.alwara.uml.sequence.controller;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.GraphicalEditPart;

import com.alwara.uml.controller.EditPartWithListener;
import com.alwara.uml.sequence.controller.editpolicy.MessageEditPolicy;
import com.alwara.uml.sequence.model.MessageModel;
import com.alwara.uml.sequence.view.MessageFigure;

/**
 * @author Virender Singh Dogra
 */
public class MessageEditPart extends EditPartWithListener {

   /**
    * {@inheritDoc}
    */
   protected IFigure createFigure() {
      return new MessageFigure(getMessage());
   }

   private MessageModel getMessage() {
      return (MessageModel) getModel();
   }

   /**
    * {@inheritDoc}
    */
   protected void createEditPolicies() {
      installEditPolicy(EditPolicy.COMPONENT_ROLE, new MessageEditPolicy());
   }

   protected void refreshVisuals() {
      Rectangle constraint = getMessage().getConstraint();
      ((GraphicalEditPart)getParent()).setLayoutConstraint(this, getFigure(), constraint);
   }

}
