package com.alwara.uml.sequence.controller;

import java.util.List;

import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.XYLayout;
import org.eclipse.gef.EditPolicy;

import com.alwara.uml.controller.EditPartWithListener;
import com.alwara.uml.sequence.controller.editpolicy.SequenceDiagramEditPolicy;
import com.alwara.uml.sequence.model.SequenceDiagramModel;
import com.alwara.uml.sequence.view.SequenceDiagramFigure;

/**
 * @author Virender Singh Dogra
 */
public class SequenceDiagramEditPart extends EditPartWithListener {

   /**
    * {@inheritDoc}
    */
   protected IFigure createFigure() {
      Figure newFigure = new SequenceDiagramFigure();
      newFigure.setLayoutManager(new XYLayout());
      return newFigure;
   }

   /**
    * {@inheritDoc}
    */
   protected void createEditPolicies() {
      installEditPolicy(EditPolicy.CONTAINER_ROLE, null);
      installEditPolicy(EditPolicy.LAYOUT_ROLE, new SequenceDiagramEditPolicy());
   }
   
   protected List getModelChildren() {
      //TODO: should add messages also to this list
      return getSequenceDiagram().getMessages();
   }
   
   public SequenceDiagramModel getSequenceDiagram() {
      return (SequenceDiagramModel) getModel();
   }
}
