/*
 * Created on Jan 2, 2005
 */
package com.alwara.uml.sequence.controller.editpolicy;

import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.XYLayoutEditPolicy;
import org.eclipse.gef.requests.CreateRequest;

import com.alwara.uml.clazz.controller.command.ChangeConstraintCommand;
import com.alwara.uml.sequence.controller.command.InstanceAddCommand;
import com.alwara.uml.sequence.model.InstanceModel;
import com.alwara.uml.sequence.model.SequenceDiagramModel;

/**
 * @author Virender Singh Dogra
 */
public class SequenceDiagramEditPolicy extends XYLayoutEditPolicy {

   protected Command getCreateCommand(CreateRequest request) {
      Object newObject = request.getNewObject();
      
      SequenceDiagramModel diagramModel = (SequenceDiagramModel) getHost().getModel();
      InstanceAddCommand instanceAddCommand = new InstanceAddCommand();
      
      InstanceModel instanceModel = (InstanceModel) newObject;
      instanceModel.setConstraint((Rectangle) getConstraintFor(request));
      
      instanceAddCommand.setSequenceDiagramModel(diagramModel);
      instanceAddCommand.setInstanceModel(instanceModel);
      return instanceAddCommand;
   }

   protected Command createAddCommand(EditPart child, Object constraint) {
      return null;
   }

   /**
    * {@inheritDoc}
    */
   protected Command createChangeConstraintCommand(EditPart child, Object constraint) {
      ChangeConstraintCommand command = new ChangeConstraintCommand();
      command.setModel(child.getModel());
      command.setConstraint((Rectangle) constraint);
      
      return command;
   }

   /**
    * {@inheritDoc}
    */
   protected Command getDeleteDependantCommand(Request request) {
      return null;
   }

   /**
    * {@inheritDoc}
    */
   public Command getCommand(Request request) {
      System.out.println(request.getType());
      return super.getCommand(request);
   }
}
