/*
 * Created on Jan 15, 2005
 */
package com.alwara.uml.sequence.model;

import java.util.Collection;
import java.util.Collections;

import org.eclipse.draw2d.geometry.Rectangle;

import com.alwara.uml.model.AbstractModel;

/**
 * @author Virender Singh Dogra
 */
public class InstanceModel extends AbstractModel {
   /** serialVersionUID */
   private static final long serialVersionUID = 1L;
   /** name of this instance */
   private String instanceName_;
   /** type of this instance */
   private String type_;
   /** stereotypes implemented by this instance */
   private Collection sterotypes_ = Collections.EMPTY_SET;
   private Rectangle constraint_;
   private SequenceDiagramModel sequenceDiagramModel_;

   /**
    * @param instanceName
    * @param type
    * @param sterotypes
    */
   public InstanceModel(String instanceName, String type, Collection sterotypes) {
      instanceName_ = instanceName;
      type_ = type;
      sterotypes_ = sterotypes;
   }
   
   /**
    * @return Returns the instanceName_.
    */
   public String getInstanceName() {
      return instanceName_;
   }
   
   /**
    * @return Returns the sterotypes_.
    */
   public Collection getSterotypes() {
      return sterotypes_;
   }
   
   /**
    * @return Returns the type_.
    */
   public String getType() {
      return type_;
   }

   public Rectangle getConstraint() {
      return constraint_;
   }
   
   public void setConstraint(Rectangle constraint) {
      constraint_ = constraint;
      firePropertyChange(CONSTRAINT, null, constraint);
   }

   public void setDiagramModel(SequenceDiagramModel sequenceDiagramModel) {
      sequenceDiagramModel_ = sequenceDiagramModel;
   }
}
