/*
 * Created on Jan 15, 2005
 */
package com.alwara.uml.sequence.model;

import org.eclipse.draw2d.geometry.Rectangle;

import com.alwara.uml.model.AbstractModel;

/**
 * @author Virender Singh Dogra
 */
public class MessageModel extends AbstractModel {
   /** serialVersionUID */
   private static final long serialVersionUID = 1L;
   
   /** the source instance from which the message originates */
   private InstanceModel sourceInstance_;

   /** the target instance to which the message goes */
   private InstanceModel targetInstance_;

   /** the method that gets called */
   private MethodModel method_;

   private Rectangle constraint_;

   /**
    * @param sourceInstance
    * @param targetInstance
    * @param method
    */
   public MessageModel(InstanceModel sourceInstance, InstanceModel targetInstance,
            MethodModel method) {
      this.sourceInstance_ = sourceInstance;
      this.targetInstance_ = targetInstance;
      this.method_ = method;
   }
   
   public InstanceModel getSourceInstance() {
      return sourceInstance_;
   }

   public InstanceModel getTargetInstance() {
      return targetInstance_;
   }

   public MethodModel getMethod() {
      return method_;
   }

   public Rectangle getConstraint() {
      return constraint_;
   }

   public void setConstraint(Rectangle constraint) {
      constraint_ = constraint;
   }

}
