/*
 * Created on Jan 15, 2005
 */
package com.alwara.uml.sequence.model;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.eclipse.jdt.core.IMethod;

import com.alwara.uml.model.AbstractModel;


/**
 * @author Virender Singh Dogra
 */
public class SequenceDiagramModel extends AbstractModel {
   /** serialVersionUID */
   private static final long serialVersionUID = 1L;

   /** store the unique list of instances */
   private Set instances_ = new HashSet();
   
   /** store the messages */
   private List messages_ = new ArrayList();

   private IMethod sequenceMethod_;

   /**
    * @param methodElement
    */
   public SequenceDiagramModel(IMethod methodElement) {
      sequenceMethod_ = methodElement;
   }

   /**
    * @param message
    */
   public void addMessage(MessageModel message) {
      addInstance(message.getSourceInstance());
      addInstance(message.getTargetInstance());
      messages_.add(message);
      firePropertyChange(CHILD, null, message);
   }

   /**
    * @return the list of messages in the model
    */
   public List getMessages() {
      return messages_;
   }

   public void removeMessage(MessageModel message){
      messages_.remove(message);
      firePropertyChange(CHILD, null, message);
   }
   
   public void addInstance(InstanceModel instance){
      instances_.add(instance);
   }
   
   public List getInstances(){
      List instances = Arrays.asList(instances_.toArray());
      return instances;
   }
   
   public void removeInstance(InstanceModel instance){
      instances_.remove(instance);
      firePropertyChange(CHILD, null, instance);
   }
}
