/*
 * Created on Jan 1, 2005
 */
package com.alwara.uml.sequence.view;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.widgets.Display;

import com.alwara.uml.sequence.model.InstanceModel;
import com.alwara.uml.view.IconImage;

/**
 * @author Virender Singh Dogra
 */
public class InstanceFigure extends Figure {
   private final InstanceModel instance_;

   public final static Color instanceColor = new Color(null, 252, 254, 204);

   /**
    * @param instance
    */
   public InstanceFigure(InstanceModel instance) {
      instance_ = instance;

      ToolbarLayout layout = new ToolbarLayout();
      layout.setSpacing(2);
      setLayoutManager(layout);
      
      
      Label stereotypeLabel = new Label("<<" + instance.getType() + ">>");

      Label label = new Label(instance.getInstanceName() + " : " + instance.getType(), 
                              IconImage.getFittingImage(instance));

      setBorder(new LineBorder(ColorConstants.black, 1));
      setBackgroundColor(instanceColor);
      setOpaque(true);

      label.setFont(getDecorationFont());

      add(stereotypeLabel);
      add(label);
//      add(new LifeLineFigure(instance));
   }

   /**
    * @return the font to decorate the class
    */
   private Font getDecorationFont() {
      FontData fontData = Display.getCurrent().getSystemFont().getFontData()[0];
      fontData.setStyle(SWT.BOLD);

      return new Font(null, fontData);
   }
}