/*
 * Created on Jan 16, 2005
 */
package com.alwara.uml.sequence.view;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.widgets.Display;

import com.alwara.uml.sequence.model.MessageModel;

/**
 * @author Virender Singh Dogra
 */
public class MessageFigure extends Figure {

   private MessageModel message_;
   public final static Color messageColor = ColorConstants.green;

   /**
    * @param message
    */
   public MessageFigure(MessageModel message) {
      message_ = message;
      

      ToolbarLayout layout = new ToolbarLayout();
      layout.setSpacing(2);
      setLayoutManager(layout);

      Label label = new Label(message.getMethod().getName());

      setBorder(new LineBorder(ColorConstants.black, 1));
      setBackgroundColor(messageColor);
      setOpaque(true);

      label.setFont(getDecorationFont());

      add(label);
   }


   /**
    * @return the font to decorate the class
    */
   private Font getDecorationFont() {
      FontData fontData = Display.getCurrent().getSystemFont().getFontData()[0];
      fontData.setStyle(SWT.BOLD);

      return new Font(null, fontData);
   }

}
