/*
 * Created on Jan 3, 2005
 */
package com.alwara.uml.sequence.view;

import org.eclipse.gef.EditPartViewer;
import org.eclipse.gef.Request;
import org.eclipse.gef.dnd.AbstractTransferDropTargetListener;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.jdt.core.ICompilationUnit;
import org.eclipse.jdt.core.IMethod;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.dnd.DND;
import org.eclipse.swt.dnd.FileTransfer;
import org.eclipse.swt.dnd.Transfer;

import com.alwara.uml.sequence.model.InstanceModelFactory;
import com.alwara.uml.sequence.model.SequenceDiagramModelFactory;
import com.alwara.uml.utils.InspectJavaElementUtils;

/**
 * @author Virender Singh Dogra
 */
public class MethodDropListener extends AbstractTransferDropTargetListener {

   private SequenceDiagramModelFactory sequenceDiagramModelFactory_ = new SequenceDiagramModelFactory();
   private InstanceModelFactory instanceModelFactory_ = new InstanceModelFactory();

   public MethodDropListener(EditPartViewer viewer, Transfer xfer) {
      super(viewer, xfer);
   }

   public MethodDropListener(EditPartViewer viewer) {
      super(viewer, FileTransfer.getInstance());
   }

   /**
    * {@inheritDoc}
    * Setting the current drop location on the request.
    */
   protected void updateTargetRequest() {
      ((CreateRequest) getTargetRequest()).setLocation(getDropLocation());
   }

   protected Request createTargetRequest() {
      CreateRequest request = new CreateRequest();
//      request.setFactory(sequenceDiagramModelFactory_);
      request.setFactory(instanceModelFactory_);
      return request;
   }

   /**
    * {@inheritDoc}
    * Now since we'll be dragging files from the Navigator (or any file explorer), we
    * want to ensure that the file won't be deleted. To do this, override handleDragOver() and set
    * the drop detail to DND.DROP_COPY. If we leave it as the default (DND.DROP_MOVE), after the
    * drop the drag source will assume the file is somewhere else and remove the original. We want
    * the file to stay right where it is.
    */
   protected void handleDragOver() {
      getCurrentEvent().detail = DND.DROP_COPY;
      super.handleDragOver();
   }

   protected void handleDrop() {
      String fullFileName = ((String[]) getCurrentEvent().data)[0];

      ICompilationUnit javaElement = InspectJavaElementUtils.getCompilationUnit(fullFileName);
      
      IMethod methodElement = getMethodElement(javaElement);
      
      instanceModelFactory_.setType(javaElement.findPrimaryType().getElementName());
      instanceModelFactory_.setInstanceName(javaElement.findPrimaryType().getElementName());
      
      super.handleDrop();
   }

   private IMethod getMethodElement(ICompilationUnit javaName) {
      IMethod methodElement = null;
//      new SourceType( ).getMethod("new method", null);

      return methodElement;
   }

}