/*
 * Created on Jan 8, 2005
 */
package com.alwara.uml.utils;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IWorkspaceRoot;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.Path;
import org.eclipse.jdt.core.Flags;
import org.eclipse.jdt.core.ICompilationUnit;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jdt.core.JavaCore;
import org.eclipse.jdt.core.JavaModelException;

/**
 * @author Virender Singh Dogra
 */
public class InspectJavaElementUtils {
   static Logger logger_ = Logger.getLogger(InspectJavaElementUtils.class);
   
   public static boolean isInterfaceOrAbstract(ICompilationUnit clazz) {
      boolean isInterfaceOrAbstract = false;
      
      if (clazz != null) {
         try {
            if ((clazz.findPrimaryType().isInterface()) || (isAbstract(clazz))) {
               isInterfaceOrAbstract = true;
            }
         }
         catch (Exception e) {
            logger_.error("Failed to resolve modifier", e);
            e.printStackTrace();
         }
      }
   
      return isInterfaceOrAbstract;
   }

   public static boolean isAbstract(ICompilationUnit clazz) {
      boolean isAbstract = false;
      if (clazz != null) {
         try {
            isAbstract = Flags.isAbstract(clazz.findPrimaryType().getFlags());
         }
         catch (JavaModelException e) {
            logger_.error("Failed to resolve modifier", e);
            e.printStackTrace();
         }
      }      
      return isAbstract;
   }

   public static boolean isClazz(ICompilationUnit clazz) {
      boolean isClazz = false;
      
      if (clazz != null) {
         try {
            isClazz = clazz.findPrimaryType().isClass(); 
         }
         catch (JavaModelException e) {
            logger_.error("Failed to resolve modifier", e);
            e.printStackTrace();
         }
      }      
      return isClazz;
   }

   public static final ICompilationUnit getCompilationUnit(String fullFileName) {
      IWorkspaceRoot root = ResourcesPlugin.getWorkspace().getRoot();
      ICompilationUnit javaElement = null;
   
      if (org.eclipse.jdt.internal.core.util.Util.isJavaLikeFileName(fullFileName)) {
         IFile file = root.getFileForLocation(new Path(fullFileName));
         javaElement = JavaCore.createCompilationUnitFrom(file);
      }
      return javaElement;
   }

   public static final IJavaProject getProject() {
      IJavaProject javaProject = JavaCore.create(ResourcesPlugin.getWorkspace().getRoot().getProject());
      return javaProject;
   }

}
