/*
 * Created on Jan 3, 2005
 */
package com.alwara.uml.view;

import org.eclipse.swt.layout.GridLayout;

/**
 * @author Virender Singh Dogra
 */
public class LayoutUtil {
   /**
    * Comment for <code>VERTICAL_SPACING</code>
    */
   public static final int 
                  MARGIN_WIDTH = 8,
                  MARGIN_HEIGHT = 8,
                  HORIZONTAL_SPACING = 4,
                  VERTICAL_SPACING = 4;

   /**
    * @return the layout
    */
   public static GridLayout createLayout() {
       GridLayout layout = new GridLayout();
       layout.marginWidth = MARGIN_WIDTH;
       layout.marginHeight = MARGIN_HEIGHT;
       layout.horizontalSpacing = HORIZONTAL_SPACING;
       layout.verticalSpacing = VERTICAL_SPACING;
       return layout;
   }

   /**
    * @return border less layout
    */
   public static GridLayout createBorderlessLayout() {
       GridLayout layout = new GridLayout();
       layout.marginWidth = 0;
       layout.marginHeight = 0;
       layout.horizontalSpacing = 0;
       layout.verticalSpacing = 0;
       return layout;
   }

   private LayoutUtil() {
   }

   /**
    * @param numCols
    * @return border less layout with columns
    */
   public static GridLayout createBorderlessLayout( int numCols ) {
       GridLayout layout = LayoutUtil.createBorderlessLayout();
       layout.numColumns = numCols;
       return layout;
   }
}


